# bossbar
execute store result bossbar jjba_justice value run data get entity @e[type=vindicator,tag=justice,limit=1,sort=nearest] Health
execute as @e[type=vindicator,tag=justice] at @s as @a[distance=..64] run bossbar set jjba_justice visible true
execute as @e[type=vindicator,tag=justice] at @s as @a[distance=..64] run bossbar set jjba_justice players @s
execute as @e[type=vindicator,tag=justice] at @s as @a[distance=64..] run bossbar set jjba_justice visible false

# scores
execute as @e[type=vindicator,tag=justice] run scoreboard players add @s jjba_clock 1

# rotation synchronization
execute as @e[type=armor_stand,tag=justice] store result entity @s Rotation[0] float 1 run data get entity @e[type=vindicator,tag=justice,limit=1,sort=nearest] Rotation[0]
execute as @e[type=armor_stand,tag=justice] store result entity @s Rotation[1] float 1 run data get entity @e[type=vindicator,tag=justice,limit=1,sort=nearest] Rotation[1]

# Justice spirit form
execute as @s[type=vindicator,tag=spirit_form] run data merge entity @s {Attributes:[{Name:generic.follow_range,Base:0}]}
execute as @s[type=vindicator,tag=spirit_form] run execute as @e[type=armor_stand,tag=justice,limit=1,sort=nearest] unless entity @s[nbt={ArmorItems:[{},{},{},{id:"minecraft:golden_hoe",tag:{CustomModelData:30002}}]}] run item replace entity @s armor.head with minecraft:golden_hoe{CustomModelData:30002}
execute as @s[type=vindicator,tag=spirit_form] run effect give @s minecraft:resistance 1 4 true
execute as @s[type=vindicator,tag=spirit_form] run effect give @s minecraft:weakness 1 0 true
execute as @s[type=vindicator,tag=spirit_form] at @s unless entity @e[tag=justice_puppet,distance=..50] run playsound minecraft:boss.justice_spirit master @a ~ ~ ~ 0.75 1
execute as @s[type=vindicator,tag=spirit_form] at @s unless entity @e[tag=justice_puppet,distance=..50] run tag @s remove spirit_form

# sound effects
execute as @e[type=vindicator,tag=spirit_form] if entity @s[scores={jjba_clock=1}] at @s if predicate minecraft:rng/5 run playsound minecraft:boss.justice_laugh_1 master @a ~ ~ ~ 0.75 1
execute as @e[type=vindicator,tag=spirit_form] if entity @s[scores={jjba_clock=1}] at @s if predicate minecraft:rng/5 run playsound minecraft:boss.justice_laugh_2 master @a ~ ~ ~ 0.75 1

# Justice physical form
execute as @s[type=vindicator,tag=!spirit_form] run data merge entity @s {Attributes:[{Name:generic.follow_range,Base:16}]}
execute as @s[type=vindicator,tag=!spirit_form] run execute as @e[type=armor_stand,tag=justice,limit=1,sort=nearest] unless entity @s[tag=justice_hurt] unless entity @s[nbt={ArmorItems:[{},{},{},{id:"minecraft:golden_hoe",tag:{CustomModelData:30001}}]}] run item replace entity @s armor.head with minecraft:golden_hoe{CustomModelData:30001}
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] if predicate minecraft:rng/25 at @s if entity @e[type=#jjba:sentient,distance=0.1..5] run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0 0 0 0.1 75
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] if predicate minecraft:rng/25 at @s if entity @e[type=#jjba:sentient,distance=0.1..5] run playsound minecraft:boss.justice_attack master @a ~ ~ ~ 0.5 1
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] if predicate minecraft:rng/25 at @s run effect give @e[type=#jjba:sentient,distance=0.1..5] minecraft:slowness 5 1 true
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] if predicate minecraft:rng/25 at @s run effect give @e[type=#jjba:sentient,distance=0.1..5] minecraft:mining_fatigue 5 2 true
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] if predicate minecraft:rng/25 at @s run effect give @e[type=#jjba:sentient,distance=0.1..5] minecraft:weakness 5 0 true
execute as @s[type=vindicator,tag=!spirit_form] run effect give @s minecraft:slowness 1 0 true
execute as @s[type=vindicator,tag=!spirit_form] run effect clear @s minecraft:resistance

# zombie respawning
execute as @e[type=vindicator,tag=!spirit_form] store result score @s jjba_hp run data get entity @s Health
execute as @e[type=vindicator,tag=!spirit_form] run execute as @e[type=armor_stand,tag=justice,limit=1,sort=nearest] if predicate minecraft:rng/25 run scoreboard players add @s jjba_clock 1
execute as @e[type=vindicator,tag=!spirit_form,scores={jjba_hp=76..}] run execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run summon minecraft:zombie_villager ~ ~ ~ {Johnny:1b,CanPickUpLoot:0b,Team:"jjba_justic_team",Tags:["justice_puppet"]}
execute as @e[type=vindicator,tag=!spirit_form,scores={jjba_hp=76..}] run execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run summon minecraft:zombie_villager ~ ~ ~ {Johnny:1b,CanPickUpLoot:0b,Team:"jjba_justic_team",Tags:["justice_puppet"]}
execute as @e[type=vindicator,tag=!spirit_form] run execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run summon minecraft:zombie_villager ~ ~ ~ {Johnny:1b,CanPickUpLoot:0b,Team:"jjba_justic_team",Tags:["justice_puppet"]}
execute as @e[type=vindicator,tag=!spirit_form] run execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run summon minecraft:zombie_villager ~ ~ ~ {Johnny:1b,CanPickUpLoot:0b,Team:"jjba_justic_team",Tags:["justice_puppet"]}
execute as @e[type=vindicator,tag=!spirit_form] run execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run summon minecraft:zombie_villager ~ ~ ~ {Johnny:1b,CanPickUpLoot:0b,Team:"jjba_justic_team",Tags:["justice_puppet"]}
execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] at @s run playsound minecraft:boss.justice_summon master @a ~ ~ ~ 0.75 1
execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] at @s run tag @e[type=vindicator,limit=1,sort=nearest] add spirit_form
execute as @e[type=armor_stand,tag=justice,scores={jjba_clock=120..}] run scoreboard players reset @s jjba_clock

# hurt animation
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[nbt={HurtTime:10s}] at @s run playsound minecraft:entity.skeleton.hurt master @a ~ ~ ~ 0.75 0.5
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[nbt={HurtTime:10s}] at @s run tag @e[type=armor_stand,tag=justice,limit=1,sort=nearest] add justice_hurt
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=1}] run execute at @e[type=armor_stand,tag=justice_hurt,limit=1,sort=nearest] run playsound minecraft:entity.skeleton.hurt master @a ~ ~ ~ 0.75 0.5
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=..39}] run execute as @e[type=armor_stand,tag=justice_hurt,limit=1,sort=nearest] unless entity @s[nbt={ArmorItems:[{},{},{},{id:"minecraft:golden_hoe",tag:{CustomModelData:30003}}]}] run item replace entity @s armor.head with minecraft:golden_hoe{CustomModelData:30003}
execute as @e[type=vindicator,tag=!spirit_form] if entity @s[scores={jjba_clock=40}] run tag @e[type=armor_stand,tag=justice_hurt,limit=1,sort=nearest] remove justice_hurt

# zombie behavior
execute as @e[type=vindicator,tag=justice] if entity @s[scores={jjba_clock=1}] at @e[tag=justice_puppet,distance=..16] run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0.3 0.5 0.3 0 2
execute as @e[tag=justice_puppet] at @s if predicate minecraft:rng/33 run execute as @e[type=#jjba:sentient,distance=0.1..2.5,nbt={HurtTime:8s}] unless entity @s[nbt={ActiveEffects:[{Id:4b}]}] unless entity @s[nbt={ActiveEffects:[{Id:18b}]}] run effect give @s minecraft:slowness 5 0 true
execute as @e[tag=justice_puppet] at @s if predicate minecraft:rng/33 run execute as @e[type=#jjba:sentient,distance=0.1..2.5,nbt={HurtTime:8s}] unless entity @s[nbt={ActiveEffects:[{Id:2b}]}] unless entity @s[nbt={ActiveEffects:[{Id:18b}]}] run effect give @s minecraft:mining_fatigue 5 0 true
execute as @e[tag=justice_puppet] at @s if predicate minecraft:rng/33 run execute as @e[type=#jjba:sentient,distance=0.1..2.5,nbt={HurtTime:8s}] unless entity @s[nbt={ActiveEffects:[{Id:2b}]}] unless entity @s[nbt={ActiveEffects:[{Id:4b}]}] run effect give @s minecraft:weakness 5 0 true
execute as @e[tag=justice_puppet] at @s unless entity @e[tag=justice,distance=..16] run tp @s @e[tag=justice,limit=1,sort=nearest]

# death animation
execute as @e[type=armor_stand,tag=justice] at @s unless entity @e[type=vindicator,tag=justice,distance=..2] run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0.5 0.5 0.5 0.25 150
execute as @e[type=armor_stand,tag=justice] at @s unless entity @e[type=vindicator,tag=justice,distance=..2] run playsound minecraft:boss.justice_death master @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=justice] at @s unless entity @e[type=vindicator,tag=justice,distance=..2] run loot spawn ~ ~1.5 ~ loot minecraft:justice
execute as @e[type=armor_stand,tag=justice] at @s unless entity @e[type=vindicator,tag=justice,distance=..2] run bossbar remove jjba_justice
execute as @e[type=armor_stand,tag=justice] at @s unless entity @e[type=vindicator,tag=justice,distance=..2] run kill @s

# escape in daytime
execute as @e[type=vindicator,tag=justice] at @s if predicate minecraft:sunrise if predicate minecraft:clear if predicate minecraft:total_light run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0.5 0.5 0.5 0.25 150
execute as @e[type=vindicator,tag=justice] at @s if predicate minecraft:sunrise if predicate minecraft:clear if predicate minecraft:total_light run tp @s ~ ~-500 ~
execute as @e[type=vindicator,tag=justice] at @s if predicate minecraft:sunset if predicate minecraft:clear if predicate minecraft:total_light run particle minecraft:campfire_cosy_smoke ~ ~1 ~ 0.5 0.5 0.5 0.25 150
execute as @e[type=vindicator,tag=justice] at @s if predicate minecraft:sunset if predicate minecraft:clear if predicate minecraft:total_light run tp @s ~ ~-500 ~

# score resetting
execute as @e[type=vindicator,tag=justice] if entity @s[scores={jjba_clock=41..}] run scoreboard players reset @s jjba_clock
