# tags user and mobs/players
execute as @e[predicate=overworld,type=#jjba:sentient,distance=..25] run tag @s add overworld
execute as @e[predicate=nether,type=#jjba:sentient,distance=..25] run tag @s add nether
execute as @e[predicate=end,type=#jjba:sentient,distance=..25] run tag @s add end

# creates clones in alternate dimension

execute as @e[type=!player,tag=overworld,distance=..25] at @s in jjba:alt_overworld run function jjba:stands/d4c/dimension_hop/alt_clones
execute as @e[type=!player,tag=nether,distance=..25] at @s in jjba:alt_nether run function jjba:stands/d4c/dimension_hop/alt_clones
execute as @e[type=!player,tag=end,distance=..25] at @s in jjba:alt_end run function jjba:stands/d4c/dimension_hop/alt_clones

execute as @e[type=player,distance=..25] at @s run function jjba:stands/d4c/dimension_hop/player_clones
execute as @e[predicate=overworld,type=villager,tag=alt_player] at @s in jjba:alt_overworld run tp @s ~ ~ ~
execute as @e[predicate=nether,type=villager,tag=alt_player] at @s in jjba:alt_nether run tp @s ~ ~ ~
execute as @e[predicate=end,type=villager,tag=alt_player] at @s in jjba:alt_end run tp @s ~ ~ ~

# teleports user to alternate dimension
execute as @s[tag=overworld] at @s in jjba:alt_overworld run tp @s ~ ~ ~
execute as @s[tag=nether] at @s in jjba:alt_nether run tp @s ~ ~ ~
execute as @s[tag=end] at @s in jjba:alt_end run tp @s ~ ~ ~

# searches for safe location

execute as @s[tag=overworld] at @s run spreadplayers ~ ~ 0 16 under 319 false @s
execute as @s[tag=nether] at @s run spreadplayers ~ ~ 0 16 under 127 false @s
execute as @s[tag=end] at @s run spreadplayers ~ ~ 0 16 under 255 false @s

execute as @s[predicate=alt_overworld,tag=alt_clone] at @s run spreadplayers ~ ~ 0 16 under 319 false @s
execute as @s[predicate=alt_nether,tag=alt_clone] at @s run spreadplayers ~ ~ 0 16 under 127 false @s
execute as @s[predicate=alt_end,tag=alt_clone] at @s run spreadplayers ~ ~ 0 16 under 255 false @s

execute at @s run kill @e[type=armor_stand,tag=d4c,distance=10..100]

# effects
execute at @s run playsound minecraft:stand.d4c_hop master @a ~ ~ ~ 0.56 1
execute at @s run particle minecraft:explosion ~ ~1 ~ 0 0 0 1 1

# removes tags
tag @e[tag=overworld] remove overworld
tag @e[tag=nether] remove nether
tag @e[tag=end] remove end
