# speeds up daylight cycle
execute as @s run function jjba:stands/heaven/acceleration/daylight_cycle

# tags mobs/players
execute as @e[tag=!accelerated,distance=..100] unless entity @s[tag=heaven] run tag @s add accelerated
execute as @e[tag=accelerated,distance=100..] run function jjba:stands/heaven/acceleration/remove_tags

# modifies mob growth speed
execute as @e[type=#jjba:breedable,tag=accelerated] unless entity @s[type=minecraft:player] run function jjba:stands/heaven/acceleration/mob_growth

# entity gravity
execute as @e[type=#jjba:projectile,tag=accelerated] unless entity @s[type=#jjba:motion_projectile] run data merge entity @s {NoGravity:1b}
execute as @e[type=#jjba:insentient,tag=accelerated] unless entity @s[type=#jjba:item] unless entity @s[type=#jjba:projectile] at @s if block ~ ~-1 ~ #jjba:airs run tp @s ~ ~-0.5 ~

# modifies fuse time
execute as @e[type=tnt,tag=accelerated] run data merge entity @s {Fuse:0}
execute as @e[type=creeper,tag=accelerated] run data merge entity @s {ExplosionRadius:-1}

# user effects
execute as @s run function jjba:stands/heaven/acceleration/effects

# mob/player effects

execute as @s[scores={jjba_stat_power=1}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:hunger 1 0 true
execute as @s[scores={jjba_stat_power=2}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:hunger 1 1 true
execute as @s[scores={jjba_stat_power=3}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:hunger 1 2 true
execute as @s[scores={jjba_stat_power=4}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:hunger 1 3 true
execute as @s[scores={jjba_stat_power=5}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:hunger 1 4 true

execute as @s at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:weakness 1 0 true

execute as @s[scores={jjba_stat_power=1..2}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:mining_fatigue 1 0 true
execute as @s[scores={jjba_stat_power=3..4}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:mining_fatigue 1 1 true
execute as @s[scores={jjba_stat_power=5}] at @s run execute as @e[type=#jjba:sentient,tag=accelerated] run effect give @s minecraft:mining_fatigue 1 2 true

# visual effects
particle minecraft:instant_effect ~ ~1 ~ 0.3 0.5 0.3 0 5 force
