# looping timer
execute as @s[scores={jjba_clock=..9}] run scoreboard players add @s jjba_clock 1
execute as @s[scores={jjba_clock=10..}] run scoreboard players set @s jjba_clock 0

# tags mobs/players
execute as @s[scores={jjba_stat_range=1}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~3 ~ as @e[type=!#jjba:insentient,tag=!moon_whirl,distance=..6] run tag @s add whirling
execute as @s[scores={jjba_stat_range=2}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~3 ~ as @e[type=!#jjba:insentient,tag=!moon_whirl,distance=..18] run tag @s add whirling
execute as @s[scores={jjba_stat_range=3}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~3 ~ as @e[type=!#jjba:insentient,tag=!moon_whirl,distance=..10] run tag @s add whirling
execute as @s[scores={jjba_stat_range=4}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~3 ~ as @e[type=!#jjba:insentient,tag=!moon_whirl,distance=..12] run tag @s add whirling
execute as @s[scores={jjba_stat_range=5}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~3 ~ as @e[type=!#jjba:insentient,tag=!moon_whirl,distance=..16] run tag @s add whirling

# summons armor stand
execute at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] unless entity @e[type=armor_stand,tag=whirlpool] run summon minecraft:armor_stand ~ ~ ~ {Invisible:1b,Marker:1b,Tags:["whirlpool"]}

# entity spinning motion
execute at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~ ~4 as @e[tag=whirling,type=!player,dx=50,dy=50,dz=50] run data merge entity @s {Motion:[-1.8d,0.01d,-0.2d]}
execute at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~-4 ~ ~ as @e[tag=whirling,type=!player,dx=-50,dy=50,dz=50] run data merge entity @s {Motion:[0.2d,0.01d,-1.8d]}
execute at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~ ~ ~-4 as @e[tag=whirling,type=!player,dx=-50,dy=50,dz=-50] run data merge entity @s {Motion:[1.8d,0.01d,0.2d]}
execute at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] positioned ~4 ~ ~ as @e[tag=whirling,type=!player,dx=50,dy=50,dz=-50] run data merge entity @s {Motion:[-0.2d,0.01d,1.8d]}

# effects
execute as @s[scores={jjba_clock=1}] at @e[type=armor_stand,tag=moon,limit=1,sort=nearest] run playsound minecraft:stand.moon_whirlpool master @a ~ ~ ~ 0.45 1
execute as @e[type=armor_stand,tag=moon,limit=1,sort=nearest] at @s positioned ~ ~-3 ~ run function jjba:stands/moon/whirlpool/particles
execute as @e[tag=whirling] at @s run particle minecraft:crit ~ ~0.5 ~ 0.2 0.4 0.2 0 3

# damages mobs/players
execute as @s[scores={jjba_clock=0..,jjba_stat_power=1}] run scoreboard players set @e[tag=whirling] jjba_damage 25
execute as @s[scores={jjba_clock=0..,jjba_stat_power=2}] run scoreboard players set @e[tag=whirling] jjba_damage 30
execute as @s[scores={jjba_clock=0..,jjba_stat_power=3}] run scoreboard players set @e[tag=whirling] jjba_damage 45
execute as @s[scores={jjba_clock=0..,jjba_stat_power=4}] run scoreboard players set @e[tag=whirling] jjba_damage 60
execute as @s[scores={jjba_clock=0..,jjba_stat_power=5}] run scoreboard players set @e[tag=whirling] jjba_damage 75
execute as @e[tag=whirling] run function mcprng:dmg

# whirlpool movement
execute as @e[type=armor_stand,tag=whirlpool,limit=1,sort=nearest] at @s rotated ~ 0 run tp @p[tag=whirling] ^ ^4 ^4
execute as @e[type=armor_stand,tag=whirlpool,limit=1,sort=nearest] at @s run tp @s ~ ~ ~ ~10 ~
execute as @e[type=armor_stand,tag=moon,limit=1,sort=nearest] at @s run tp @s ~ ~ ~ ~45 ~
tag @e[tag=whirling] remove whirling
