# regulates stand deployment
execute as @s[scores={jjba_active=1..21},tag=!stand_active] at @s run function jjba:stands/crazy/stand/summon_stand
execute as @s[scores={jjba_active=21},tag=stand_active] at @s run function jjba:stands/crazy/stand/stand_active
execute as @s[scores={jjba_active=-16..-1}] at @s run function jjba:stands/crazy/stand/dismiss_stand

# initiates active abilities

execute as @s[scores={jjba_head_f=1}] run tag @s add attack_1
execute as @s[scores={jjba_head_f=1}] run tag @s add barrage_5
execute as @s[scores={jjba_head_q=1,jjba_ab_3=1}] run tag @s add attack_2
execute as @s[scores={jjba_head_q=1,jjba_ab_3=1,jjba_current_ab=0}] run tag @s add attack_2a
execute as @s[scores={jjba_head_q=1,jjba_ab_3=1,jjba_current_ab=1}] run tag @s add attack_2b
execute as @s[scores={jjba_head_q=1,jjba_ab_3=1,jjba_current_ab=2}] run tag @s add attack_2c

execute as @s[scores={jjba_head_Q=1,jjba_ab_3=1,jjba_attack_2=0}] run scoreboard players add @s jjba_current_ab 1
execute as @s[scores={jjba_current_ab=1..,jjba_stat_power=1..2}] run scoreboard players set @s jjba_current_ab 0
execute as @s[scores={jjba_current_ab=2..,jjba_stat_power=3..4}] run scoreboard players set @s jjba_current_ab 0
execute as @s[scores={jjba_current_ab=3..,jjba_stat_power=5}] run scoreboard players set @s jjba_current_ab 0
execute as @s[scores={jjba_head_Q=1,jjba_ab_3=1,jjba_attack_2=0,jjba_current_ab=0}] run tellraw @s ["",{"text":"Current mode: ","italic":true,"color":"gray"},{"text":"Healing","italic":true}]
execute as @s[scores={jjba_head_Q=1,jjba_ab_3=1,jjba_attack_2=0,jjba_current_ab=1}] run tellraw @s ["",{"text":"Current mode: ","italic":true,"color":"gray"},{"text":"Repair","italic":true}]
execute as @s[scores={jjba_head_Q=1,jjba_ab_3=1,jjba_attack_2=0,jjba_current_ab=2}] run tellraw @s ["",{"text":"Current mode: ","italic":true,"color":"gray"},{"text":"Disassembly","italic":true}]

# runs active abilities
execute as @s[tag=attack_1] at @s run function jjba:stands/crazy/barrage/barrage
execute as @s[tag=attack_2] at @s run function jjba:stands/crazy/restoration/ability

# bossbars

execute as @s store result bossbar jjba_crazy_1 value run scoreboard players get @s jjba_cooldown_1
execute as @s[scores={jjba_attack_1=0,jjba_cooldown_1=0}] run bossbar set minecraft:jjba_crazy_1 name [{"text":"Attack : ","color":"white"},{"text":"head+","color":"yellow"},{"keybind":"key.swapOffhand","color":"yellow"},{"text":" to start","color":"yellow"}]
execute as @s[scores={jjba_active=1..,jjba_attack_1=1..}] run bossbar set minecraft:jjba_crazy_1 name [{"text":"Attack : head+","bold":true,"underlined":true,"color":"green"},{"keybind":"key.swapOffhand","bold":true,"underlined":true,"color":"green"},{"text":" to stop","bold":true,"underlined":true,"color":"green"}]
execute as @s[scores={jjba_attack_1=0,jjba_cooldown_1=1..}] run bossbar set minecraft:jjba_crazy_1 name [{"text":"Attack : ","color":"dark_gray"},{"text":"head+","color":"dark_gray"},{"keybind":"key.swapOffhand","color":"dark_gray"},{"text":" to start","color":"dark_gray"}]

execute as @s store result bossbar jjba_crazy_2 value run scoreboard players get @s jjba_cooldown_2
execute as @s[scores={jjba_ab_3=1,jjba_attack_2=0,jjba_cooldown_2=0}] run bossbar set minecraft:jjba_crazy_2 name [{"text":"Restoration : ","color":"white"},{"text":"head+","color":"yellow"},{"keybind":"key.drop","color":"yellow"},{"text":" to start","color":"yellow"}]
execute as @s[scores={jjba_ab_3=1,jjba_attack_2=1..}] run bossbar set minecraft:jjba_crazy_2 name [{"text":"Restoration : head+","bold":true,"underlined":true,"color":"green"},{"keybind":"key.drop","bold":true,"underlined":true,"color":"green"},{"text":" to stop","bold":true,"underlined":true,"color":"green"}]
execute as @s[scores={jjba_ab_3=1,jjba_attack_2=0,jjba_cooldown_2=1..}] run bossbar set minecraft:jjba_crazy_2 name [{"text":"Restoration : ","color":"dark_gray"},{"text":"head+","color":"dark_gray"},{"keybind":"key.drop","color":"dark_gray"},{"text":" to start","color":"dark_gray"}]

# controls head
execute unless entity @s[nbt={Inventory:[{Slot:0b,id:"minecraft:scute",Count:1b,tag:{stand_head:1b}}]}] run clear @s minecraft:scute{stand_head:1b}
execute unless entity @s[nbt={Inventory:[{Slot:0b}]}] run item replace entity @s hotbar.0 with minecraft:scute{stand_head:1b,display:{Name:"{\"text\":\"§e『Crazy Diamond』\"}"},CustomModelData:100001}
kill @e[distance=..10,type=item,nbt={Item:{id:"minecraft:scute",tag:{stand_head:1b}}}]
