# tags nearest mobs/players

execute as @s[scores={jjba_stat_range=1}] at @s run execute as @e[type=#jjba:sentient,distance=..10] run tag @s add gold_target
execute as @s[scores={jjba_stat_range=2}] at @s run execute as @e[type=#jjba:sentient,distance=..15] run tag @s add gold_target
execute as @s[scores={jjba_stat_range=3}] at @s run execute as @e[type=#jjba:sentient,distance=..25] run tag @s add gold_target
execute as @s[scores={jjba_stat_range=4}] at @s run execute as @e[type=#jjba:sentient,distance=..35] run tag @s add gold_target
execute as @s[scores={jjba_stat_range=5}] at @s run execute as @e[type=#jjba:sentient,distance=..50] run tag @s add gold_target

execute as @s[scores={jjba_stat_range=1}] at @s run execute as @e[tag=gold_target,distance=11..] run tag @s remove gold_target
execute as @s[scores={jjba_stat_range=2}] at @s run execute as @e[tag=gold_target,distance=16..] run tag @s remove gold_target
execute as @s[scores={jjba_stat_range=3}] at @s run execute as @e[tag=gold_target,distance=26..] run tag @s remove gold_target
execute as @s[scores={jjba_stat_range=4}] at @s run execute as @e[tag=gold_target,distance=36..] run tag @s remove gold_target
execute as @s[scores={jjba_stat_range=5}] at @s run execute as @e[tag=gold_target,distance=51..] run tag @s remove gold_target

# removes area effect clouds
execute as @s[scores={jjba_stat_range=1}] at @s run execute as @e[tag=gold_marker,distance=11..] run kill @s
execute as @s[scores={jjba_stat_range=2}] at @s run execute as @e[tag=gold_marker,distance=16..] run kill @s
execute as @s[scores={jjba_stat_range=3}] at @s run execute as @e[tag=gold_marker,distance=26..] run kill @s
execute as @s[scores={jjba_stat_range=4}] at @s run execute as @e[tag=gold_marker,distance=36..] run kill @s
execute as @s[scores={jjba_stat_range=5}] at @s run execute as @e[tag=gold_marker,distance=51..] run kill @s

# clears effects
execute as @s[scores={jjba_attack_3=1..}] run effect clear @e[tag=gold_target] minecraft:blindness
execute as @s[scores={jjba_attack_3=1..}] run effect clear @e[tag=gold_target] minecraft:weakness
execute as @s[scores={jjba_attack_3=1..}] run effect clear @e[tag=gold_target] minecraft:slowness

# marker summoning

execute as @s run scoreboard players add @s jjba_clock 1

execute as @s[scores={jjba_stat_range=1,jjba_clock=5..10}] run kill @e[tag=gold_marker]
execute as @s[scores={jjba_stat_range=2,jjba_clock=25..30}] run kill @e[tag=gold_marker]
execute as @s[scores={jjba_stat_range=3,jjba_clock=45..50}] run kill @e[tag=gold_marker]
execute as @s[scores={jjba_stat_range=4,jjba_clock=65..70}] run kill @e[tag=gold_marker]
execute as @s[scores={jjba_stat_range=5,jjba_clock=85..90}] run kill @e[tag=gold_marker]

execute as @s[scores={jjba_stat_range=1,jjba_clock=15}] run execute as @e[tag=gold_target] unless entity @s[tag=gold_rewind] at @s run function jjba:stands/gold/return_to_zero/markers
execute as @s[scores={jjba_stat_range=2,jjba_clock=35}] run execute as @e[tag=gold_target] unless entity @s[tag=gold_rewind] at @s run function jjba:stands/gold/return_to_zero/markers
execute as @s[scores={jjba_stat_range=3,jjba_clock=55}] run execute as @e[tag=gold_target] unless entity @s[tag=gold_rewind] at @s run function jjba:stands/gold/return_to_zero/markers
execute as @s[scores={jjba_stat_range=4,jjba_clock=75}] run execute as @e[tag=gold_target] unless entity @s[tag=gold_rewind] at @s run function jjba:stands/gold/return_to_zero/markers
execute as @s[scores={jjba_stat_range=5,jjba_clock=95}] run execute as @e[tag=gold_target] unless entity @s[tag=gold_rewind] at @s run function jjba:stands/gold/return_to_zero/markers

execute as @s[scores={jjba_stat_range=1,jjba_clock=20}] run scoreboard players set @s jjba_clock 0
execute as @s[scores={jjba_stat_range=2,jjba_clock=40}] run scoreboard players set @s jjba_clock 0
execute as @s[scores={jjba_stat_range=3,jjba_clock=60}] run scoreboard players set @s jjba_clock 0
execute as @s[scores={jjba_stat_range=4,jjba_clock=80}] run scoreboard players set @s jjba_clock 0
execute as @s[scores={jjba_stat_range=5,jjba_clock=100}] run scoreboard players set @s jjba_clock 0

# rewind
execute as @s[tag=gold_rewind,scores={jjba_clock=101..102}] run execute as @e[tag=gold_target] at @s positioned ~0.5 ~0.5 ~0.5 run function jjba:stands/gold/return_to_zero/rewind
execute as @s[tag=gold_rewind,scores={jjba_clock=103..}] run function jjba:stands/gold/return_to_zero/result
